=== debian/changelog ===
mlt (7.12.0-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 16 Feb 2023 14:45:22 -0800

mlt (7.12.0-1) unstable; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 22 Nov 2022 15:11:24 +0100
