## mlt 7.12.0-1~ubuntu22.04.1+11.0trisquel2

=== debian/changelog ===
mlt (7.12.0-1~ubuntu22.04.1+11.0trisquel2) aramo-backports; urgency=medium

  * Backported from official PPA for kdenlive as a dependency of
    kdenlive

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sun, 20 Nov 2022 18:39:33 +0000

mlt (7.12.0-1~ubuntu22.04.1) jammy; urgency=low

  * Auto build.

 -- Julius Künzel <jk.kdedev@smartlab.uber.space>  Sun, 20 Nov 2022 12:38:10 +0000
