=== debian/control ===
--- 
+++ 
@@ -1,52 +1,49 @@
 Source: mlt
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
-Build-Depends: chrpath,
-               cmake,
-               debhelper-compat (= 13),
-               dh-python,
-               ffmpeg,
-               frei0r-plugins-dev,
-               imagemagick,
-               ladspa-sdk,
-               libarchive-dev,
-               libavdevice-dev,
-               libavformat-dev,
-               libdv4-dev,
-               libebur128-dev (>= 1.2.0-2),
-               libexif-dev,
-               libfftw3-dev,
-               libgdk-pixbuf2.0-dev,
-               libjack-dev,
-               libmovit-dev,
-               libopencv-dev,
-               libpango1.0-dev,
-               libqt5opengl5-dev,
-               libqt5svg5-dev,
-               librtaudio-dev [linux-any],
-               librubberband-dev,
-               libsamplerate-dev,
-               libsdl1.2-dev,
-               libsdl2-dev,
-               libsox-dev (>= 14.3.0),
-               libswscale-dev,
-               libvidstab-dev,
-               libvorbis-dev,
-               libxine2-dev,
-               libxml2-dev,
-               python3-dev,
-               swig
-Standards-Version: 4.6.1
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+Build-Depends: debhelper-compat (= 12),
+ ffmpeg,
+ libqt5opengl5-dev,
+ libqt5svg5-dev,
+ ladspa-sdk,
+ libavdevice-dev,
+ libavformat-dev,
+ libdv4-dev,
+ libexif-dev,
+ libgdk-pixbuf2.0-dev,
+ libmovit-dev,
+ libfftw3-dev,
+ libjack-dev,
+ libpango1.0-dev,
+ libsamplerate-dev,
+ libsdl1.2-dev,
+ libsdl2-dev,
+ libsox-dev (>= 14.3.0),
+ libswscale-dev,
+ librubberband-dev,
+ libvorbis-dev,
+ libvidstab-dev,
+ libxine2-dev,
+ libxml2-dev,
+ librtaudio-dev [linux-any],
+ imagemagick,
+ frei0r-plugins-dev,
+ swig,
+ libebur128-dev (>= 1.2.0-2),
+ python3-dev,
+ dh-python,
+ cmake
+Standards-Version: 4.5.1
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://www.mltframework.org
 
-Package: libmlt-dev
+Package: libmlt7-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmlt7 (= ${binary:Version}), ${misc:Depends}
+Depends: ${misc:Depends},
+ libmlt7 (= ${binary:Version})
 Description: multimedia framework (development)
  MLT is an open source multimedia framework, designed and developed for
  television broadcasting. It provides a toolkit for broadcasters, video
@@ -61,8 +58,9 @@
 Package: libmlt7
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Recommends: libmlt-data (>= ${source:Version})
+Depends: ${shlibs:Depends},
+ ${misc:Depends}
+Recommends: libmlt7-data (>= ${source:Version})
 Description: multimedia framework (runtime)
  MLT is an open source multimedia framework, designed and developed for
  television broadcasting. It provides a toolkit for broadcasters, video
@@ -74,7 +72,7 @@
  This package contains the files necessary for running applications that
  use the MLT multimedia framework.
 
-Package: libmlt-data
+Package: libmlt7-data
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
@@ -89,11 +87,12 @@
  .
  This package contains the data files for the MLT multimedia framework.
 
-Package: libmlt++-dev
+Package: libmlt++7-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libmlt++7 (= ${binary:Version}), ${misc:Depends}
+Depends: libmlt++7 (= ${binary:Version}),
+ ${misc:Depends}
 Description: MLT multimedia framework C++ wrapper (development)
  MLT is an open source multimedia framework, designed and developed for
  television broadcasting. It provides a toolkit for broadcasters, video
@@ -108,7 +107,8 @@
 Package: libmlt++7
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${shlibs:Depends},
+ ${misc:Depends}
 Description: MLT multimedia framework C++ wrapper (runtime)
  MLT is an open source multimedia framework, designed and developed for
  television broadcasting. It provides a toolkit for broadcasters, video
@@ -120,19 +120,23 @@
  This package contains the files necessary for running applications that
  use the MLT multimedia framework C++ wrapper.
 
-Package: melt
+Package: melt-7
 Section: utils
 Architecture: any
-Depends: libmlt-data (>= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends: ${shlibs:Depends},
+ ${misc:Depends},
+ libmlt7-data (>= ${source:Version})
 Description: command line media player and video editor
  melt was meant as a test tool for the MLT framework, but it is also a powerful
  multitrack command line oriented video editor. It could also used as an
  minimalistic media player for audio and video files.
 
-Package: python3-mlt
+Package: python3-mlt7
 Architecture: any
 Section: python
-Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Depends: ${shlibs:Depends},
+ ${misc:Depends},
+ ${python3:Depends}
 Provides: ${python3:Provides}
 Conflicts: python-mlt
 Replaces: python-mlt
